package org.yoshiori.llspirit;

import javafx.ui.*;
import javafx.ui.canvas.*;
import javafx.ui.filter.*;

import java.lang.System;
import java.lang.Math;


public class ContentSequence extends BaseView {
  public attribute current: Number;
  public attribute contents: Content*;
  public attribute content: Content;
  public attribute template: Template;
   
  public operation next();
  public operation back();

}
attribute ContentSequence.template = Template{
  content: bind content
};

attribute ContentSequence.contents = [
  Content{
    node:Group{
      content:[
        Text{
          fill: white
          content:"VMɓĖႦȂJavaFXScript"
          font:Font { face: bind fontFace, size: height / 20 }
          x:100
          y:height/2
        },
        Text{
          fill: red
          content:"()"
          font:Font { face: bind fontFace, size: height/20 }
          x:500
          y:height/2
          transform: bind [translate( 0,0),rotate([0..360] dur 5000 linear continue if true ,380, height/2) ]
        }
      ]
    }
  },
  Content{
    node:Group{
      content:[
        Text{
          fill: white
          content:"ɂ"
          font:Font { face: bind fontFace, size: height / 5 }
          x:10
          y:height/2 - 100
        },
        Text{
          fill: white
          content:"VIłB"
          font:Font { face: bind fontFace, size: height / 5 }
          x:10
          y:height/2 + 100
        }
      ]
    }
  },
  Content{
    node: Text{
      fill: white
      content:"ȏЉ"
      font:Font { face: bind fontFace, size: height / 5 }
      x:100
      y:height/2 - 50
    }
  },
  Content{
    node: Text{
      fill: white
      content:"i"
      font:Font { face: bind fontFace, size: height / 2 }
      x:30
      y:100
    }
  },
  Content{
    node: Text{
      fill: white
      content:"JavaFX script"
      font:Font { face: bind fontFace, size: height / 10 }
      x:100
      y:height/2 - 50
    }
  },
  Content{
    node: Text{
      fill: white
      content:"VII"
      font:Font { face: bind fontFace, size: height / 5 }
      x:100
      y:height/2 - 50
    }
  },
  Content{
    node:Group{
      content:[
        Text {
          fill: white
          content:"2007/05/08"
          font:Font { face: bind fontFace, size: height / 12 }
          x:10
          y:drawY + height / 12
        },
        Text {
          fill: white
          content:"JavaOne Ŕ\"
          font:Font { face: bind fontFace, size: height / 12 }
          x:10
          y:drawY + height / 12 * 2
        },
        Group {
          transform: [translate(height / 7, drawY + height / 12 * 3)]
          content: ImageView {
//            image: Image {url: "{__DIR__}/images/javaone.jpg"}
            image: Image {url: "{__DIR__}/images/javafx.png"}
          }
        }
      ]
    }
  },
  Content{
    node: ImageView {
      image: Image {url: "{__DIR__}/images/lu.png"}
    }
  },
  Content{
    node: Text{
      fill: white
      content:"cc"
      font:Font { face: bind fontFace, size: height / 5 }
      x:100
      y:height/2
    }
  },
  Content{
    node: Text{
      fill: white
      content:"JVM œ ! !"
      font:Font { face: bind fontFace, size: height / 5 }
      x:10
      y:height/2 - 50
    }
  },
  Content{
    node:Group{
      content:[
        Text {
          fill: white
          content:"JRE1.5 ȏオKv"
          font:Font { face: bind fontFace, size: height / 12 }
          x:10
          y:drawY + height / 12
        },
        Text {
          fill: white
          content:" OS œ"
          font:Font { face: bind fontFace, size: height / 12 }
          x:10
          y:drawY + height / 12 * 2
        },
        ImageView {
            image: Image {url: "{__DIR__}/images/jvm.png"}
        }
      ]
    }
  },
  Content{
    node: ImageView {
      image: Image {url: "{__DIR__}/images/vmd.png"}
    }
  },
  Content{
    node: Text{
      fill: white
      content:"cc"
      font:Font { face: bind fontFace, size: height / 5 }
      x:100
      y:height/2
    }
  },
  Content{
    node: Text{
      fill: white
      content:"GUI쐬 ! !"
      font:Font { face: bind fontFace, size: height / 5 }
      x:10
      y:height/2 - 50
    }
  },
  Content{
    node:Group{
      content:[
        Text {
          fill: white
          content:"b`GUI쐬ɓKĂ"
          font:Font { face: bind fontFace, size: height / 12 }
          x:10
          y:drawY + height / 12
        },
        Text {
          fill: white
          content:"̃v[̂ FX ŋLq"
          font:Font { face: bind fontFace, size: height / 12 }
          x:10
          y:drawY + height / 12 * 2
        },
        ImageView {
            image: Image {url: "{__DIR__}/images/tesla.png"}
        }
      ]
    }
  },
  Content{
    node: ImageView {
      image: Image {url: "{__DIR__}/images/pd.png"}
    }
  },
  Content{
    node: Text{
      fill: white
      content:"cc"
      font:Font { face: bind fontFace, size: height / 5 }
      x:100
      y:height/2
    }
  },
  Content{
    node: ImageView {
      image: Image {url: "{__DIR__}/images/zetubou.png"}
    }
  },
  Content{
    node: ImageView {
      image: Image {url: "{__DIR__}/images/fx.png"}
    }
  },
  Content{
    node:Group{
      content:[
        Text {
          fill: white
          content:"JavaFX framework"
          font:Font { face: bind fontFace, size: height / 12 }
          x:10
          y:drawY + height / 12
        },
        ImageView {
            image: Image {url: "{__DIR__}/images/jff.png"}
        }
      ]
    }
  },
  Content{
    node:Group{
      content:[
        Text {
          fill: white
          content:"JavaFX ̂"
          font:Font { face: bind fontFace, size: height / 12 }
          x:10
          y:drawY + height / 12
        },
        Text {
          fill: white
          content:"RIA ɊւeNmW̃t@~"
          font:Font { face: bind fontFace, size: height / 12 }
          x:10
          y:drawY + height / 12 * 2
        },
        Text {
          fill: white
          content:"JavaFX Script "
          font:Font { face: bind fontFace, size: height / 12 }
          x:10
          y:drawY + height / 12 * 4
        },
        Text {
          fill: white
          content:"JavaFX framework œ"
          font:Font { face: bind fontFace, size: height / 12 }
          x:10
          y:drawY + height / 12 * 5 
        },
        Text {
          fill: white
          content:"XNvg"
          font:Font { face: bind fontFace, size: height / 12 }
          x:10
          y:drawY + height / 12 * 6 
        }
      ]
    }
  },
  Content{
    node: Text{
      fill: white
      content:"JavaFX scriptɂ"
      font:Font { face: bind fontFace, size: height / 10 }
      x:100
      y:height/2 - 50
    }
  },
  Content{
    node:Group{
      content:[
        Text {
          fill: white
          content:"錾^Lq"
          font:Font { face: bind fontFace, size: height / 12 }
          x:10
          y:drawY + height / 12
        },
        ImageView {
            image: Image {url: "{__DIR__}/images/code.png"}
        }
      ]
    }
  },
  Content{
    node:Group{
      content:[
        Text {
          fill: white
          content:"z̑"
          font:Font { face: bind fontFace, size: height / 12 }
          x:10
          y:drawY + height / 12
        },
        Text {
          fill: white
          content:"SQL̂悤 query "
          font:Font { face: bind fontFace, size: height / 12 }
          x:10
          y:drawY + height / 12 * 2
        },
        Text {
          fill: white
          content:"ANZXo"
          font:Font { face: bind fontFace, size: height / 12 }
          x:10
          y:drawY + height / 12 * 3 
        },
        ImageView {
            image: Image {url: "{__DIR__}/images/array.png"}
        }
      ]
    }
  },
  Content{
    node:Group{
      content:[
        Text {
          fill: white
          content:"ȒPɃAj[V"
          font:Font { face: bind fontFace, size: height / 12 }
          x:10
          y:drawY + height / 12
        },
        Rect {
          width: bind [0..100] dur 1000 continue if true
          height: 50
          arcHeight: 20
          arcWidth: 20
          //opacity: bind opacityValue
          // transform: bind [translate(80, 50), rotate(rotationValue, width/2, height/2)]
          fill: dodgerblue
          stroke: darkblue
          strokeWidth: 2
          x: 10
          y:drawY + height/12 * 2
        },
        Rect {
          width: 100
          height: bind [0..50] dur 1000 continue if true
          arcHeight: 20
          arcWidth: 20
          //opacity: bind opacityValue
          // transform: bind [translate(80, 50), rotate(rotationValue, width/2, height/2)]
          fill: dodgerblue
          stroke: darkblue
          strokeWidth: 2
          x: 210
          y:drawY + height/12 * 2
        },
        Rect {
          width: 100
          height: 50
          arcHeight: bind [0..50] dur 1000 continue if true
          arcWidth: 20
          //opacity: bind opacityValue
          // transform: bind [translate(80, 50), rotate(rotationValue, width/2, height/2)]
          fill: dodgerblue
          stroke: darkblue
          strokeWidth: 2
          x: 410
          y:drawY + height/12 * 2
        },
        Rect {
          width: 100
          height: 50
          arcHeight: 20
          arcWidth: 20
          opacity: bind [0.01,0.02..1.00] dur 1000 continue if true
          // transform: bind [translate(80, 50), rotate(rotationValue, width/2, height/2)]
          fill: dodgerblue
          stroke: darkblue
          strokeWidth: 2
          x: 610
          y:drawY + height/12 * 2
       },
       Morph{
        fill: dodgerblue
        start: Rect{
          x: 100
          y:drawY + height/12 * 2 + 100
          width:600
          height:100
        }
        end: Circle{
          cx: 100
          cy: drawY + height/12 * 2 + 100
          radius: 50
        }
        morph: bind [0.01,0.02..1.00] dur 2000 continue if true
       },
       ImageView {
          image: Image {url: "{__DIR__}/images/anime.png"}
        }
      ]
    }
  },
  Content{
    node:Group{
      content:[
        Text {
          fill: white
          content:""
          font:Font { face: bind fontFace, size: height / 12 }
          x:10
          y:drawY + height / 12
        },
        Text {
          fill: white
          content:"View  HTML ŏ"
          font:Font { face: bind fontFace, size: height / 12 }
          x:10
          y:drawY + height / 12 * 2
        },
        ImageView {
            image: Image {url: "{__DIR__}/images/html.png"}
        }
      ]
    }
  },
  Content{
    node:Group{
      content:[
        Text {
          fill: white
          content:""
          font:Font { face: bind fontFace, size: height / 12 }
          x:10
          y:drawY + height / 12
        },
        Text {
          fill: white
          content:"JVM œĂ̂"
          font:Font { face: bind fontFace, size: height / 12 }
          x:10
          y:drawY + height / 12 * 2
        },
        Text {
          fill: white
          content:"WbNDȌŏ"
          font:Font { face: bind fontFace, size: height / 12 }
          x:10
          y:drawY + height / 12 * 3
        },
        Text {
          fill: white
          content:"JRuby,Jython,Pnuts,JavaScript"
          font:Font { face: bind fontFace, size: height / 12 }
          x:10
          y:drawY + height / 12 * 4 
        },
        Text {
          fill: white
          content:"Java,Groovy,Scalacc"
          font:Font { face: bind fontFace, size: height / 12 }
          x:10
          y:drawY + height / 12 * 5 
        }
      ]
    }
  },
  Content{
    node: Text{
      fill: white
      content:"܂"
      font:Font { face: bind fontFace, size: height / 5 }
      x:10
      y:height/2 - 50
    }
  },
  Content{
    node: Text{
      fill: white
      content:"DȌ"
      font:Font { face: bind fontFace, size: height / 5 }
      x:10
      y:height/2 - 50
    }
  },
  Content{
    node: Text{
      fill: white
      content:"gݍ킹"
      font:Font { face: bind fontFace, size: height / 5 }
      x:10
      y:height/2 - 50
    }
  },
  Content{
    node: Text{
      fill: white
      content:"1񏑂"
      font:Font { face: bind fontFace, size: height / 5 }
      x:10
      y:height/2 - 50
    }
  },
  Content{
    node: Text{
      fill: white
      content:"ł"
      font:Font { face: bind fontFace, size: height / 5 }
      x:10
      y:height/2 - 50
    }
  },
  Content{
    node: Text{
      fill: white
      content:"܂"
      font:Font { face: bind fontFace, size: height / 5 }
      x:10
      y:height/2 - 50
    }
  },
  Content{
    node: Text{
      fill: white
      content:"MashupI"
      font:Font { face: bind fontFace, size: height / 5 }
      x:0
      y:height/2 - 50
    }
  },
  Content{
    node: Text{
      fill: white
      content:"ꂼ"
      font:Font { face: bind fontFace, size: height / 5 }
      x:10
      y:height/2 - 50
    }
  },
  Content{
    node: Text{
      fill: white
      content:" 2.0 II"
      font:Font { face: bind fontFace, size: height / 5 }
      x:10
      y:height/2 - 50
    }
  },
  Content{
    node: Text{
      fill: white
      content:"J"
      font:Font { face: bind fontFace, size: height / 5 }
      x:10
      y:height/2 - 50
    }
  },
  Content{
    node: Text{
      fill: white
      content:""
      font:Font { face: bind fontFace, size: height / 5 }
      x:10
      y:height/2 - 50
    }
  },
  Content{
    node: Text{
      fill: white
      content:"JVM̃^["
      font:Font { face: bind fontFace, size: height / 5 }
      x:10
      y:height/2 - 50
    }
  },
  Content{
    node: Text{
      fill: white
      content:"cc"
      font:Font { face: bind fontFace, size: height / 5 }
      x:10
      y:height/2 - 50
    }
  },
  Content{
    node: Text{
      fill: white
      content:"߂Ȃ"
      font:Font { face: bind fontFace, size: height / 5 }
      x:10
      y:height/2 - 50
    }
  },
  Content{
    node:Group{
      content:[
        Text {
          fill: white
          content:"RIA"
          font:Font { face: bind fontFace, size: height / 12 }
          x:10
          y:drawY + height / 12
        },
        ImageView {
            image: Image {url: "{__DIR__}/images/ria.png"}
        }
      ]
    }
  },
  Content{
    node:Group{
      content:[
        Text {
          fill: white
          content:"Ղ"
          font:Font { face: bind fontFace, size: height / 12 }
          x:10
          y:drawY 
        },
        ImageView {
            image: Image {url: "{__DIR__}/images/game.png"}
        }
      ]
    }
  },
  Content{
    node:Group{
      content:[
        Text {
          fill: white
          content:"𗧂N"
          font:Font { face: bind fontFace, size: height / 12 }
          x:10
          y:drawY + height / 12
        },
        Text {
          fill: white
          content:"OpenJFX"
          font:Font { face: bind fontFace, size: height / 12 }
          x:10
          y:drawY + height / 12 * 3
        },
        Text {
          fill: white
          content:"https://openjfx.dev.java.net/ja/"
          font:Font { face: bind fontFace, size: height / 20 }
          x:10
          y:drawY + height / 12 * 4
        },
        Text {
          fill: white
          content:"Lingr"
          font:Font { face: bind fontFace, size: height / 12 }
          x:10
          y:drawY + height / 12 * 6
        },
        Text {
          fill: white
          content:"http://www.lingr.com/room/javafx"
          font:Font { face: bind fontFace, size: height / 20 }
          x:10
          y:drawY + height / 12 * 7 
        }
      ]
    }
  },


  Content{
    node:Group{
      content:[
        Text {
          fill: white
          content:"Ò肪Ƃ܂"
          font:Font { face: bind fontFace, size: height / 12 }
          x:10
          y:height/2
        },
        ImageView {
            image: Image {url: "{__DIR__}/images/ani.png"}
        }
      ]
    }
  } 
];

attribute ContentSequence.content = contents[0];

operation ContentSequence.next(){
  System.out.println('next');
  if(current < (sizeof contents)-1){
    content = contents[++current];
    System.out.println(current);
  }
}
operation ContentSequence.back(){
  if(current > 0){
    content = contents[--current];
  }
}

operation ContentSequence.composeNode(){
  return template;
}
